// Playground - noun: a place where people can play

import Foundation

func say(whatToSay: String) {
    let task = NSTask()
    task.launchPath = "/usr/bin/say"
    task.arguments = [whatToSay]
    task.launch()
}
// gateway address for MH200N and port
let addr = "10.0.0.40"
let port = 20000

// enter devices and initial status
var cucinaString = "OFF"

var buffer = [UInt8](count: 255, repeatedValue: 0)

var inp : NSInputStream?
var out : NSOutputStream?

NSStream.getStreamsToHostWithName(addr, port: port, inputStream: &inp, outputStream: &out)

if inp != nil && out != nil {
    let inputStream : NSInputStream = inp!
    let outputStream : NSOutputStream = out!
    inputStream.open()
    outputStream.open()
    
    if outputStream.streamError == nil && inputStream.streamError == nil {
        let queryString: String = "*99*1##"
        let queryData: NSData = queryString.dataUsingEncoding(NSUTF8StringEncoding, allowLossyConversion: false)!
        while true {
            outputStream.write(UnsafePointer(queryData.bytes),maxLength:queryData.length)
            var readChars: Int = inputStream.read(&buffer, maxLength: buffer.count)
            if (readChars > 0) {
                let readString: String = NSString(data: NSData(bytes:buffer, length:readChars), encoding: NSUTF8StringEncoding)! as String
                switch readString {
                case "*#*1##" : print(readString)
                case "*1*0*51##" :  cucinaString = "OFF"
                                    print("Kitchen is OFF",readString)
                case "*1*1*51##" :  cucinaString = "ON"
                                    print("Kitchen is ON",readString)
                case "*1*1*56##" :  if (cucinaString == "ON") {say ("Laundry is ON")}
                case "*1*0*56##" :  if (cucinaString == "ON") {say ("Laundry is OFF")}
                default:            say("")
                }
            } else {
                print ("server closed connection")
                inputStream.close()
                outputStream.close()
                break
            }
        }
    } else {
        print ("could not create socket")
    }
} else {
    print ("could not initialize stream")

}
